'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII  DEMO ZUM BASIC-COMPUTER UNIT M 2.0    (by DIE HARD)   IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER UNIT M 2.0 mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG: Kommunikation UNIT M 2.0 <--> UNIT MICRO ber den IIC-Bus
'            mit einer MICRO als Slave      
'            Programm fr den MASTER (UNIT M 2.0) - Beispiel 1 -
'---------------------------------------------------------------------
'
' Sie kennen bereits die Beispiele zum Betrieb von IIC-Bus Gerten an der MICRO
' In diesen Beispielen ist die MICRO immer Master und gibt damit die Geschwindigkeit
' der Datenbertragung selbst an.
' Als SLAVE ist die Geschwindigkeit eines Treibers in BASIC nicht ausreichend
' um mit einer M 2.0 zu kommunizieren.
' Diser System-Treiber ist in Maschinencode geschrieben und ausreichend schnell
' um die MICRO (oder mehrere) als SLAVE zusammen mit einer M-UNIT 2.0
' als MASTER zu betreiben.
' Es wird das gleiche Protokoll verwendet wie zu den Beispielen der
' M 2.0 als SLAVE
'
' Im Prinzip werden immer zwei Variableninhalte ausgetauscht, also
' vom Master zum Slave oder umgekehrt.
' Die Variablen knnen gewhlt werden (BYTEVARIABLE 1 bis 24)
' Das sieht nun zunchst nicht so aus als knnte man damit besonders viel
' anfangen, aber sehen sie im 2.Teil der Beispiele selbst.
' Machen sie sich jetzt mit dem Protokoll vertraut, wenn Sie es nicht schon
' von den Beispielen zu M 2.0 kennen.
'-----------------------------------------------------------------------
' ------------------------ PROTOKOLL -----------------------------------
'-----------------------------------------------------------------------
' Das Protokoll besteht immer aus:
' <ADRESSE><MEMLOC><MEM_CONTENT><MEM+1_CONTENT>

' ADRESSE:
' Eine Adresse wie beim IIC-BUS blich mit dem Bit0 als R/W Bit (0=write)
'
' MEMLOC:
' Der MASTER bertrgt im MEMLOC die Byte-Variable (1-64) die er vom SLAVE
' lesen ( er bertrgt die READ-Adresse R/W Bit=1) oder im SLAVE beschreiben
' ( er bertrgt die WRITE-Adresse R/W Bit=0)mchte.
'
' MEM_CONTENT:
' Write-Modus
' Der MASTER bertrgt in MEM_CONTENT den Inhalt der an die mit MEMLOC
' bezeichnete Variable im SLAVE geschrieben werden soll.
' Der Master erzeugt CLOCK und DATEN fr den SLAVE
'
' Read-Modus
' Der Master empfngt in MEM_CONTENT den Inhalt der mit MEMLOC bezeichnenten
' Variablen
' Der Master erzeugt den CLOCK und sendet ADRESSE und MEMLOC.
' MEM_CONTENT und MEM+1_CONTENT sendet der SLAVE, den CLOCK dazu erzeugt
' der Master
'
' MEM+1_CONTENT
' Es werden immer zwei Variableninhalte ausgetauscht. MEM+1_CONTENT ist
' die bezeichnete BYTE-Variable +1
'
' Ein Beispiel zur Verdeutlichung:
' MASTER sendet: <120><10><101><9>
' Es ist ein WRITE Befehl (Bit0=0)an die Adresse 120
' Der SLAVE wird angewiesen den Wert 101 an seine BYTE-Variable [10] und
' den Wert 9 an seine BYTE-Variable [11] zu schreiben.
' MASTER sendet: <121><10><xx><xx>
' Es ist ein READ Befehl (Bit0=1)an die Adresse 121
' Der SLAVE wird angewiesen den Wert seiner BYTE-Variable [10] und [11]
' an den MASTER zu senden.
'-----------------------------------------------------------------------------
' Treiber Variablen:
' Der System-Treiber belegt beim SLAVE fest das Byte1 und 2 der Variablen,
' beim Master das Byte 1 bis 4. Er braucht zwei zustzliche Variablen
' um die vom SLAVE bertragenen Werte zu speichern.

' Treiber Ports:
' Das Treiberprogramm (auf PAGE0) reserviert fr die MICRO als SLAVE die
' PORTS 2 u.5 (PORT2=SDA PORT5=SCL)
'
' MASTER
' Ist der MASTER eine UNIT M 2.0, sollten Sie die standardmssigen IIC-BUS PORTS
' (Port9 u. 10) verwenden. Der Bus arbeitet dann mit maximaler Geschwindigkeit.
' In diesem Fall muss also der MASTER PORT9 (SDA) mit SLAVE PORT2 (SDA)
' und MASTER PORT10 (SCL) mit SLAVE PORT5 (SCL) verbunden werden.
' Sie drfen am MASTER (wenn er eine UNIT M 2.0 ist) das LCD nicht betreiben,
' weil sich das LCD seine Leitungen mit dem IIC-BUS teilt, und die MICRO
' als SLAVE nicht in der LAGE ist zu erkennen wenn Daten am IICBUS eigentlich
' dem LCD des MASTERS gelten.
' Beachten Sie das DELAY "DATA0=DATA0" bei der READ Operation. Es ist fr die
' MICRO notwendig.                  !!!!!!!!!
' print"#START#";:put ADDR+1:put 5:DATA0=DATA0:get DATA0:get DATA1:print"#STOP#";"#OFF#";
' Beschleunigen Sie die MICRO mit "FREQ2=0" wenn Sie bei der Datenbertragung auf Probleme
' stossen (normal nicht erforderlich)
'
' Sie knnen jedoch als Master natrlich auch eine UNIT M 2.0 oder eine andere
' MICRO mit einem BASIC-Treiber auf beliebigen Ports einsetzen. Als Master
' spielt die geringere Geschwindigkeit dann keine Rolle.
'------------------------------------------------------------------------------
' Beschreibung:
' Ein einfaches Programm, der Master beschreibt die BYTE-Variablen 5 und 6
' mit zuflligen Werten und liest diese wieder zurck.
' Der SLAVE bearbeitet in diesem Fall nur die eingehenden IIC-Bus Daten
' (Interruptgesteuert)
' Der MASTER signalisiert seine Ttigkeit mit einem Klick bei jedem
' Schleifendurchlauf und einen Fehler mit einem BEEP
'------------------------------------------------------------------------


'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LIGHT        port[16]
define SLAVESDA     port[4]
define SLAVESCL     port[5]
define P            port[1]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
'--IIC BUS SLAVE DRIVER---
define ADDR        byte[1]
define MEMLOC      byte[2]
define DATA0       byte[3]
define DATA1       byte[4]
'-------------------------
'    USER PROGRAM
'-------------------------
define DSAVE0        byte[5]
define DSAVE1        byte[6]


#INIT
LIGHT=off
ADDR=&H50
MEMLOC=5
gosub BP2ENABLE

'---------------------------------------------
'            MASTERPROGRAMM
'---------------------------------------------
#MASTER
print"#ON_LCD#";:print"#INIT#";:print"#OFF#";



'---------------------------------------------
'             WRITE OPERATION
'---------------------------------------------
#SENDLOOP
'------- WILLKRLICHE DATEN ERZEUGEN ----------
DATA0=128:DATA1=1:DSAVE0=DATA0:DSAVE1=DATA1
'------- AUSGABE AM LCD -----------------------
'print"#ON_LCD#";"#L101#";"-W- ";"05 ";DATA0;" ";DATA1;"     ";"#OFF#";
'------- WRITE OPERTATION ---------------------
print "#ON_IIC#";"#START#";:put ADDR:put MEMLOC:put DATA0:put DATA1:print"#STOP#";
pause 2:beep 2,1,0

'---------------------------------------------
'            READ OPERATION
'---------------------------------------------

'----------- READ OPERTATION -----------------
print"#START#";:put ADDR+1:put 5:DATA0=DATA0:get DATA0:DATA1=DATA1:get DATA1:print"#STOP#";"#OFF#";
'---------- VERGLEICH DER DATEN AUF FEHLER ----
if (DATA0<>DSAVE0)or DATA1<>DSAVE1 then beep 5,5,0
'if (DATA0<>DSAVE0)or DATA1<>DSAVE1 then print"#ON_LCD#";"#L101#";"-R- ";"05 ";DATA0;" ";DATA1;"     ";"#OFF#";
'if (DATA0<>DSAVE0)or DATA1<>DSAVE1 then goto ende
'------- AUSGABE AM LCD -----------------------
'print"#ON_LCD#";"#L101#";"-R- ";"05 ";DATA0;" ";DATA1;"     ";"#OFF#";
pause 2:'beep 10,2,0
goto SENDLOOP
'---------------------------------------------
#ENDE
goto ende

#BP2ENABLE
print"#ON_CONFIG#";
put &B0010000
print"#OFF#";
return

